	PROGRAM Diff_Equation

! ============================================================
!
!  Exercise 3 - differential equation - parallel version
!  
! ============================================================
!
!  declarations
!
! ============================================================

	IMPLICIT NONE

	  INTEGER, PARAMETER :: n = 100
	  INTEGER :: i

	  DOUBLE PRECISION, DIMENSION(0:n) ::  diffeq, deriv
          DOUBLE PRECISION :: dx
	  DOUBLE PRECISION :: area

	  INTEGER startTime, endTime

!HPF$	  DISTRIBUTE(BLOCK) :: diffeq, deriv

! ===============================================
!
! main program
!
! ===============================================


! 	    initialize array with zeros
	    diffeq = 0

!	    solve differential equation: f(0)=0; f(x)=f(x-1)+dx

	    dx = 1.d0/n
!	    this loop cannot be independent!
	    DO i=1,n
		diffeq(i)=diffeq(i-1)+dx
	    END DO

!	    determine derivation and area
	    area = 0.d0

	    CALL SYSTEM_CLOCK(count=startTime)
!HPF$ INDEPENDENT, REDUCTION (area)
	    DO i=1,n
		deriv(i-1)=diffeq(i)-diffeq(i-1)
		area = area + deriv(i-1)
	    END DO
	    CALL SYSTEM_CLOCK(count=endTime)


!	    print some results
	    PRINT *, "diff-eqation (n)           : ", diffeq(n)
	    PRINT *, "derivation   (anywhere)    : ", deriv(0)
	    PRINT *, "area bounded by derivation : ", area
	    PRINT *, endTime-startTime
 
	END PROGRAM Diff_Equation
