	PROGRAM blockdistribution

! ============================================================
!
!  Exercise 5 - block distribution - parallel version (FORALL) 
!  
! ============================================================
!
!  declarations
!
! ============================================================

	IMPLICIT NONE

	INTEGER, PARAMETER :: MaxX = 11, MaxY = 11

        INTEGER :: x, y

        DOUBLE PRECISION, DIMENSION(MaxX, MaxY) :: field, tmpfield
!HPF$	DISTRIBUTE (BLOCK, BLOCK) :: field, tmpfield

	DOUBLE PRECISION :: dx, dy, dx2, dy2
        DOUBLE PRECISION :: dt, rand


! ============================================================
!
!  main program
!
! ============================================================


!	initialize constants
! ---------------------------------
	dx = 1.d0/MaxX
	dy = 1.d0/MaxY
	dx2 = dx*dx
	dy2 = dy*dy

	dt = MIN(dx2, dy2)/4.d0


!	initialize array
! ---------------------------------
	CALL RANDOM_SEED

	DO y=1,MaxY
	  DO x=1,MaxX
	    CALL RANDOM_NUMBER(rand)
	    IF (rand .LT. 0.5) THEN
              field(x,y)=1.d0
	    ELSE
	      field(x,y)=0.d0
	    END IF
	  END DO
	END DO

	DO y=1,MaxY
	  PRINT '(\1g9.2)', (field(x, y), x=1,MaxX)
	  PRINT *
	END DO


!	calculation
! ---------------------------------
        tmpfield = field

	FORALL (y=2:MaxY-1, x=2:MaxX-1)

	  tmpfield(x,y) = field(x,y) + &
	               ( (field(x+1,y) + field(x-1,y) - 2.d0*field(x,y))/dx2 &
	               + (field(x,y+1) + field(x,y-1) - 2.d0*field(x,y))/dy2 )&
		       * dt
	END FORALL

!	print stats
!----------------------------------

	PRINT *, "after processing..."
	DO y=1,MaxY
	  PRINT '(\1g9.2)', (tmpfield(x, y), x=1,MaxX)
	  PRINT *
	END DO


	END PROGRAM blockdistribution
